fix: don't use $functions_source for compatibility with zsh < 5.4

This commit is contained in:
Marc Cornellà 2022-08-01 20:54:45 +02:00
parent aa75eeea33
commit 4fcf52c2b1
No known key found for this signature in database
GPG key ID: 0314585E776A9C1B
2 changed files with 42 additions and 32 deletions

View file

@ -1,11 +1,14 @@
# with lots of 3rd-party amazing aliases installed, just need something to explore it quickly. # Handle $0 according to the standard:
# # https://zdharma-continuum.github.io/Zsh-100-Commits-Club/Zsh-Plugin-Standard.html
# - acs: alias cheatsheet 0="${${ZERO:-${0:#$ZSH_ARGZERO}}:-${(%):-%N}}"
# group alias by command, pass addition argv to grep. 0="${${(M)0:#/*}:-$PWD/$0}"
function acs(){
(( $+commands[python3] )) || { eval '
echo "[error] No python executable detected" function acs(){
return (( $+commands[python3] )) || {
echo "[error] No python executable detected"
return
}
alias | python3 "'"${0:h}"'/cheatsheet.py" "$@"
} }
alias | python3 ${functions_source[$0]:h}/cheatsheet.py $@ '
}

View file

@ -1,32 +1,39 @@
#!/usr/bin/bash #!/usr/bin/bash
# shellcheck disable=SC1090,SC2154 # shellcheck disable=SC1090,SC2154
proxy() { # Handle $0 according to the standard:
# deprecate $DEFAULT_PROXY, use SHELLPROXY_URL instead # https://zdharma-continuum.github.io/Zsh-100-Commits-Club/Zsh-Plugin-Standard.html
if [[ -n "$DEFAULT_PROXY" && -z "$SHELLPROXY_URL" ]]; then 0="${${ZERO:-${0:#$ZSH_ARGZERO}}:-${(%):-%N}}"
echo >&2 "proxy: DEFAULT_PROXY is deprecated, use SHELLPROXY_URL instead" 0="${${(M)0:#/*}:-$PWD/$0}"
SHELLPROXY_URL="$DEFAULT_PROXY"
unset DEFAULT_PROXY
fi
# deprecate CONFIG_PROXY, use SHELLPROXY_CONFIG instead eval '
if [[ -n "$CONFIG_PROXY" && -z "$SHELLPROXY_CONFIG" ]]; then proxy() {
echo >&2 "proxy: CONFIG_PROXY is deprecated, use SHELLPROXY_CONFIG instead" # deprecate $DEFAULT_PROXY, use SHELLPROXY_URL instead
SHELLPROXY_CONFIG="$CONFIG_PROXY" if [[ -n "$DEFAULT_PROXY" && -z "$SHELLPROXY_URL" ]]; then
unset CONFIG_PROXY echo >&2 "proxy: DEFAULT_PROXY is deprecated, use SHELLPROXY_URL instead"
fi SHELLPROXY_URL="$DEFAULT_PROXY"
unset DEFAULT_PROXY
fi
# the proxy.py script is in the same directory as this function # deprecate CONFIG_PROXY, use SHELLPROXY_CONFIG instead
local proxy="${functions_source[$0]:A:h}/proxy.py" if [[ -n "$CONFIG_PROXY" && -z "$SHELLPROXY_CONFIG" ]]; then
echo >&2 "proxy: CONFIG_PROXY is deprecated, use SHELLPROXY_CONFIG instead"
SHELLPROXY_CONFIG="$CONFIG_PROXY"
unset CONFIG_PROXY
fi
# capture the output of the proxy script and bail out if it fails # the proxy.py script is in the same directory as this function
local output local proxy="'"${0:h}"'/proxy.py"
output="$(SHELLPROXY_URL="$SHELLPROXY_URL" SHELLPROXY_CONFIG="$SHELLPROXY_CONFIG" "$proxy" "$1")" ||
return $?
# evaluate the output generated by the proxy script # capture the output of the proxy script and bail out if it fails
source <(echo "$output") local output
} output="$(SHELLPROXY_URL="$SHELLPROXY_URL" SHELLPROXY_CONFIG="$SHELLPROXY_CONFIG" "$proxy" "$1")" ||
return $?
# evaluate the output generated by the proxy script
source <(echo "$output")
}
'
_proxy() { _proxy() {
local -r commands=('enable' 'disable' 'status') local -r commands=('enable' 'disable' 'status')